diff --git a/test/common_plat/validation/api/Makefile.am b/test/common_plat/validation/api/Makefile.am
index 601bae6d2..e891c94cb 100644
--- a/test/common_plat/validation/api/Makefile.am
+++ b/test/common_plat/validation/api/Makefile.am
@@ -23,3 +23,50 @@ ODP_MODULES = atomic \
 	      system
 
 SUBDIRS = $(ODP_MODULES)
+
+include $(top_srcdir)/test/Makefile.inc
+TESTS_ENVIRONMENT += TEST_DIR=${top_builddir}/test/common_plat/validation
+
+TESTS = \
+	atomic/atomic_main$(EXEEXT) \
+	barrier/barrier_main$(EXEEXT) \
+	buffer/buffer_main$(EXEEXT) \
+	classification/classification_main$(EXEEXT) \
+	cpumask/cpumask_main$(EXEEXT) \
+	crypto/crypto_main$(EXEEXT) \
+	errno/errno_main$(EXEEXT) \
+	hash/hash_main$(EXEEXT) \
+	init/init_main_ok$(EXEEXT) \
+	init/init_main_abort$(EXEEXT) \
+	init/init_main_log$(EXEEXT) \
+	lock/lock_main$(EXEEXT) \
+	packet/packet_main$(EXEEXT) \
+	pool/pool_main$(EXEEXT) \
+	queue/queue_main$(EXEEXT) \
+	random/random_main$(EXEEXT) \
+	scheduler/scheduler_main$(EXEEXT) \
+	std_clib/std_clib_main$(EXEEXT) \
+	thread/thread_main$(EXEEXT) \
+	time/time.sh \
+	timer/timer_main$(EXEEXT) \
+	traffic_mngr/traffic_mngr.sh \
+	shmem/shmem_main$(EXEEXT) \
+	system/system_main$(EXEEXT)
+
+TESTNAME = validation
+
+TESTENV = tests-$(TESTNAME).env
+
+test_DATA = $(TESTENV)
+
+DISTCLEANFILES = $(TESTENV)
+.PHONY: $(TESTENV)
+$(TESTENV):
+	echo "TESTS=\"$(TESTS)\""    > $@
+	echo "$(TESTS_ENVIRONMENT)" >> $@
+	echo "$(LOG_COMPILER)"      >> $@
+
+if test_installdir
+installcheck-local:
+	$(DESTDIR)/$(testdir)/run-test.sh $(TESTNAME)
+endif
diff --git a/test/linux-generic/Makefile.am b/test/linux-generic/Makefile.am
index b24449884..c65a26fd7 100644
--- a/test/linux-generic/Makefile.am
+++ b/test/linux-generic/Makefile.am
@@ -1,38 +1,12 @@
 include $(top_srcdir)/test/Makefile.inc
 TESTS_ENVIRONMENT += TEST_DIR=${top_builddir}/test/common_plat/validation
 
-ALL_API_VALIDATION_DIR = ${top_builddir}/test/common_plat/validation/api
-
 SUBDIRS = performance
 
 if test_vald
 TESTS = validation/api/pktio/pktio_run.sh \
 	validation/api/pktio/pktio_run_tap.sh \
 	validation/api/shmem/shmem_linux \
-	$(ALL_API_VALIDATION_DIR)/atomic/atomic_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/barrier/barrier_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/buffer/buffer_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/classification/classification_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/cpumask/cpumask_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/crypto/crypto_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/errno/errno_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/hash/hash_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/init/init_main_ok$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/init/init_main_abort$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/init/init_main_log$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/lock/lock_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/packet/packet_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/pool/pool_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/queue/queue_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/random/random_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/scheduler/scheduler_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/std_clib/std_clib_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/thread/thread_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/time/time.sh \
-	$(ALL_API_VALIDATION_DIR)/timer/timer_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/traffic_mngr/traffic_mngr.sh \
-	$(ALL_API_VALIDATION_DIR)/shmem/shmem_main$(EXEEXT) \
-	$(ALL_API_VALIDATION_DIR)/system/system_main$(EXEEXT) \
 	ring/ring_main$(EXEEXT)
 
 SUBDIRS += validation/api/pktio\
@@ -64,17 +38,20 @@ endif
 
 TEST_EXTENSIONS = .sh
 
-dist_check_SCRIPTS = tests-validation.env $(LOG_COMPILER)
+TESTNAME = linux-generic
+
+TESTENV = tests-$(TESTNAME).env
 
-test_SCRIPTS = $(dist_check_SCRIPTS)
+test_DATA = $(TESTENV)
 
-tests-validation.env:
+DISTCLEANFILES = $(TESTENV)
+.PHONY: $(TESTENV)
+$(TESTENV):
 	echo "TESTS=\"$(TESTS)\""    > $@
 	echo "$(TESTS_ENVIRONMENT)" >> $@
 	echo "$(LOG_COMPILER)"      >> $@
 
 if test_installdir
 installcheck-local:
-	$(DESTDIR)/$(testdir)/run-test.sh
+	$(DESTDIR)/$(testdir)/run-test.sh $(TESTNAME)
 endif
-